import Factory from './Factory.ts'
import {Collection} from '../../../lib/src/collection/Collection.ts'
import {DependencyRequirement} from '../type/DependencyRequirement.ts'

export default class SingletonFactory extends Factory {
    constructor(
        protected token: FunctionConstructor,
        protected key: string,
    ) {
        super(token)
    }

    produce(dependencies: any[], parameters: any[]) {
        return this.token
    }

    match(something: any) {
        return something === this.key
    }

    get_dependency_keys(): Collection<DependencyRequirement> {
        return new Collection<DependencyRequirement>()
    }
}
